#include <assert.h>
#include <gdk/gdk.h>

#define draw_pixel(x,y)   ( gdk_draw_point(drawable, gc, x, y) )



void circle( GdkDrawable *drawable, GdkGC *gc,
             gint xc, gint yc, gint R )
{
    gint   x, y;
    gint32 Ysq, Tsq;

    x = 0;
    y = R;
    Ysq = R*R;
    Tsq = Ysq - R;

    do {/* Draw eight simmetryc archs */
        draw_pixel(xc + x, yc + y);
        draw_pixel(xc - x, yc + y);
        draw_pixel(xc + x, yc - y);
        draw_pixel(xc - x, yc - y);
        draw_pixel(xc + y, yc + x);
        draw_pixel(xc - y, yc + x);
        draw_pixel(xc + y, yc - x);
        draw_pixel(xc - y, yc - x);
        x++;
        Ysq -= x+x - 1;
        if ( Ysq <= Tsq ) {
            y--;
            Tsq -= y+y;
        }
    } while ( x <= y );

    return;
}

void circle_double( GdkDrawable *drawable, GdkGC *gc,
                    gint xc, gint yc, gint R )
{
    gint   x, y;
    gint32 Ysq, Tsq;

    x = 0;
    y = R;
    Ysq = R*R;
    Tsq = Ysq - R;

    do {/* Pixels for eight symmetric arcs */
        draw_pixel(xc + x, yc + y);
        draw_pixel(xc - x, yc + y);
        draw_pixel(xc + x, yc - y);
        draw_pixel(xc - x, yc - y);
        draw_pixel(xc + y, yc + x);
        draw_pixel(xc - y, yc + x);
        draw_pixel(xc + y, yc - x);
        draw_pixel(xc - y, yc - x);
        /* Pixels for another eight symmetric arcs inside of the outer arcs */
        if ( y > 0 ) {
            y--;
            draw_pixel(xc + x, yc + y);
            draw_pixel(xc - x, yc + y);
            draw_pixel(xc + x, yc - y);
            draw_pixel(xc - x, yc - y);
            draw_pixel(xc + y, yc + x);
            draw_pixel(xc - y, yc + x);
            draw_pixel(xc + y, yc - x);
            draw_pixel(xc - y, yc - x);
            y++;
        }
        /* Move on */
        x++;
        Ysq -= x+x - 1;
        if ( Ysq <= Tsq ) {
            y--;
            Tsq -= y+y;
        }
    } while ( x <= y );

    return;
}



/*
 * Local variables:
 * compile-command: "make -k && ./ball"
 * End:
 */
