#ifndef __WRAPPER__
#define __WRAPPER__


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* If it is GCC, assume this is Linux and SVGAlib is available */
#ifdef __GNUC__
#define __LINUX__
#endif /* __GNUC__ */

#ifdef __LINUX__
#include <vga.h>

#define VGA_INIT                vga_init(), vga_setmode(G640x480x16)
#define VGA_INIT_320x200x256    vga_init(), vga_setmode(G320x200x256)
#define VGA_INIT_1280x1024x256  vga_init(), vga_setmode(G1280x1024x256)
#define VGA_CLOSE               vga_setmode(TEXT)



#else /* __LINUX__ */
#include <graphics.h>

#define G640x200x16     VGALO
#define G640x350x16     VGAMED
#define G640x480x16     VGAHI

#define VGA_INIT        \
{\
  int driver, mode;\
\
  driver = DETECT;\
  initgraph(&driver, &mode, "");\
}

#define VGA_INIT_320x200x256        \
{\
  int driver, mode;\
\
  assert(1);\
}

#define VGA_CLOSE       closegraph()

extern int _cur_color; /* must be defined somewhere */

#define vga_getxdim()                   getmaxx()
#define vga_getydim()                   getmaxy()
#define vga_getcolors()                 getmaxcolor()

#define vga_clear()                     cleardevice()

#define vga_setcolor(COLOR)             (_cur_color = COLOR, setcolor(COLOR))
#define vga_drawpixel(X, Y)             putpixel(X, Y, _cur_color)
#define vga_drawline(X1, Y1, X2, Y2)    line(X1, Y1, X2, Y2)
#define vga_getpixel(X, Y)              getpixel(X, Y)

#endif /* __LINUX__ */


int  loadfont(int width, int height, const char *path);
void textout(int x, int y, const unsigned char *str);


#ifdef __LINUX__
#include <unistd.h>

#else /* __LINUX__ */
#include <time.h>

struct timespec {
  time_t  tv_sec;
  long    tv_nsec;
};
int nanosleep(const struct timespec *reqtime, struct timespec *remtime);
#endif /* __LINUX__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __WRAPPER__ */
