#ifndef __SPLINES_H__
#define __SPLINES_H__

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>

#include <gdk/gdk.h>
#include <gtk/gtk.h>


typedef struct _pnode {
    GdkPoint p;
    struct _pnode *next;
} pnode;


extern void   draw_splines(GdkDrawable *drawable, GdkGC *gc, pnode *points,
                           unsigned gran);
extern pnode *points_init(void);
extern pnode *point_from_coords(pnode *points, GdkPoint *coord,
                                gint16 point_radius);
extern void   draw_points( GdkDrawable *drawable, GdkGC *gc,
                           pnode *points, gint radius );
extern void   point_remove(pnode *points, pnode *p);
extern pnode *point_add(pnode *haystack, GdkPoint *point);

#endif /* __SPLINES_H__ */
