#ifndef __LIST_H__
#define __LIST_H__

#include <stdlib.h>
#include <assert.h>
#include <gdk/gdk.h>
#include <stdio.h>

class litem {
  private:
  protected:
  public:
    litem *next;
    virtual litem *copy(void)                             = 0;
    virtual void   draw(GdkDrawable *drawable, GdkGC *gc) = 0;
    virtual void   print(FILE *stream)                    = 0;
};

class list {
  private:
    int    _count;
    litem *_head;
    litem *_tail;
  protected:
  public:
    list(void) { _count = 0; _head = NULL; _tail = NULL; return; }
    ~list(void);

    int    count(void)       { return _count; }
    litem *head(void)        { return _head; }
    litem *tail(void)        { return _tail; }
    litem *add(litem *item);
    list  *copy(void);
    int    contains(litem *item);
    int    del(litem *item);
    litem *next_cycled(litem *curr);
    void   draw(GdkDrawable *drawable, GdkGC *gc);
    void   print(FILE *stream);
};




#endif /* __LIST_H__ */
